<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMemberAvailability ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfMemberAvailability
 * @subpackage Arrays
 */
class ArrayOfMemberAvailability extends AbstractStructArrayBase
{
    /**
     * The MemberAvailability
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MemberAvailability[]
     */
    public $MemberAvailability;
    /**
     * Constructor method for ArrayOfMemberAvailability
     * @uses ArrayOfMemberAvailability::setMemberAvailability()
     * @param \StructType\MemberAvailability[] $memberAvailability
     */
    public function __construct(array $memberAvailability = array())
    {
        $this
            ->setMemberAvailability($memberAvailability);
    }
    /**
     * Get MemberAvailability value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MemberAvailability[]|null
     */
    public function getMemberAvailability()
    {
        return isset($this->MemberAvailability) ? $this->MemberAvailability : null;
    }
    /**
     * This method is responsible for validating the values passed to the setMemberAvailability method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMemberAvailability method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMemberAvailabilityForArrayConstraintsFromSetMemberAvailability(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfMemberAvailabilityMemberAvailabilityItem) {
            // validation for constraint: itemType
            if (!$arrayOfMemberAvailabilityMemberAvailabilityItem instanceof \StructType\MemberAvailability) {
                $invalidValues[] = is_object($arrayOfMemberAvailabilityMemberAvailabilityItem) ? get_class($arrayOfMemberAvailabilityMemberAvailabilityItem) : sprintf('%s(%s)', gettype($arrayOfMemberAvailabilityMemberAvailabilityItem), var_export($arrayOfMemberAvailabilityMemberAvailabilityItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MemberAvailability property can only contain items of type \StructType\MemberAvailability, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MemberAvailability value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\MemberAvailability[] $memberAvailability
     * @return \ArrayType\ArrayOfMemberAvailability
     */
    public function setMemberAvailability(array $memberAvailability = array())
    {
        // validation for constraint: array
        if ('' !== ($memberAvailabilityArrayErrorMessage = self::validateMemberAvailabilityForArrayConstraintsFromSetMemberAvailability($memberAvailability))) {
            throw new \InvalidArgumentException($memberAvailabilityArrayErrorMessage, __LINE__);
        }
        if (is_null($memberAvailability) || (is_array($memberAvailability) && empty($memberAvailability))) {
            unset($this->MemberAvailability);
        } else {
            $this->MemberAvailability = $memberAvailability;
        }
        return $this;
    }
    /**
     * Add item to MemberAvailability value
     * @throws \InvalidArgumentException
     * @param \StructType\MemberAvailability $item
     * @return \ArrayType\ArrayOfMemberAvailability
     */
    public function addToMemberAvailability(\StructType\MemberAvailability $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MemberAvailability) {
            throw new \InvalidArgumentException(sprintf('The MemberAvailability property can only contain items of type \StructType\MemberAvailability, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MemberAvailability[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MemberAvailability|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MemberAvailability|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MemberAvailability|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MemberAvailability|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MemberAvailability|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MemberAvailability
     */
    public function getAttributeName()
    {
        return 'MemberAvailability';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfMemberAvailability
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
