<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ValidateSSOToken StructType
 * @subpackage Structs
 */
class ValidateSSOToken extends AbstractStructBase
{
    /**
     * The SSOToken
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SSOToken;
    /**
     * Constructor method for ValidateSSOToken
     * @uses ValidateSSOToken::setSSOToken()
     * @param string $sSOToken
     */
    public function __construct($sSOToken = null)
    {
        $this
            ->setSSOToken($sSOToken);
    }
    /**
     * Get SSOToken value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSSOToken()
    {
        return isset($this->SSOToken) ? $this->SSOToken : null;
    }
    /**
     * Set SSOToken value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sSOToken
     * @return \StructType\ValidateSSOToken
     */
    public function setSSOToken($sSOToken = null)
    {
        // validation for constraint: string
        if (!is_null($sSOToken) && !is_string($sSOToken)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sSOToken, true), gettype($sSOToken)), __LINE__);
        }
        if (is_null($sSOToken) || (is_array($sSOToken) && empty($sSOToken))) {
            unset($this->SSOToken);
        } else {
            $this->SSOToken = $sSOToken;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ValidateSSOToken
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
